# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_adcsauthorityinformationaccess`](#dsc_adcsauthorityinformationaccess): The DSC AdcsAuthorityInformationAccess resource type. Automatically generated from version 5.0.0
* [`dsc_adcscertificationauthority`](#dsc_adcscertificationauthority): The DSC AdcsCertificationAuthority resource type. Automatically generated from version 5.0.0
* [`dsc_adcscertificationauthoritysettings`](#dsc_adcscertificationauthoritysettings): The DSC AdcsCertificationAuthoritySettings resource type. Automatically generated from version 5.0.0
* [`dsc_adcsenrollmentpolicywebservice`](#dsc_adcsenrollmentpolicywebservice): The DSC AdcsEnrollmentPolicyWebService resource type. Automatically generated from version 5.0.0
* [`dsc_adcsonlineresponder`](#dsc_adcsonlineresponder): The DSC AdcsOnlineResponder resource type. Automatically generated from version 5.0.0
* [`dsc_adcstemplate`](#dsc_adcstemplate): The DSC AdcsTemplate resource type. Automatically generated from version 5.0.0
* [`dsc_adcswebenrollment`](#dsc_adcswebenrollment): The DSC AdcsWebEnrollment resource type. Automatically generated from version 5.0.0

## Resource types

### <a name="dsc_adcsauthorityinformationaccess"></a>`dsc_adcsauthorityinformationaccess`

The DSC AdcsAuthorityInformationAccess resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcsauthorityinformationaccess` type.

##### `dsc_aiauri`

Data type: `Optional[Array[String]]`

Specifies the list of URIs that should be included in the AIA extension of the issued certificate.

##### `dsc_allowrestartservice`

Data type: `Optional[Boolean]`

Allows the Certificate Authority service to be restarted if changes are made. Defaults to false.

##### `dsc_ocspuri`

Data type: `Optional[Array[String]]`

Specifies the list of URIs that should be included in the Online Responder OCSP extension of the issued certificate.

#### Parameters

The following parameters are available in the `dsc_adcsauthorityinformationaccess` type.

* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_adcscertificationauthority"></a>`dsc_adcscertificationauthority`

The DSC AdcsCertificationAuthority resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcscertificationauthority` type.

##### `dsc_cacommonname`

Data type: `Optional[String]`

Specifies the certification authority common name.

##### `dsc_cadistinguishednamesuffix`

Data type: `Optional[String]`

Specifies the certification authority distinguished name suffix.

##### `dsc_catype`

Data type: `Enum['EnterpriseRootCA', 'EnterpriseSubordinateCA', 'StandaloneRootCA', 'StandaloneSubordinateCA']`

Specifies the type of certification authority to install. The possible values are EnterpriseRootCA, EnterpriseSubordinateCA, StandaloneRootCA, or StandaloneSubordinateCA.

##### `dsc_certfile`

Data type: `Optional[String]`

Specifies the file name of certification authority PKCS 12 formatted certificate file.

##### `dsc_certificateid`

Data type: `Optional[String]`

Specifies the thumbprint or serial number of certification authority certificate.

##### `dsc_cryptoprovidername`

Data type: `Optional[String]`

The name of the cryptographic service provider or key storage provider that is used to generate or store the private key for the CA.

##### `dsc_databasedirectory`

Data type: `Optional[String]`

Specifies the folder location of the certification authority database.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Certificate Authority should be installed or uninstalled.

##### `dsc_hashalgorithmname`

Data type: `Optional[String]`

Specifies the signature hash algorithm used by the certification authority.

##### `dsc_ignoreunicode`

Data type: `Optional[Boolean]`

Specifies that Unicode characters are allowed in certification authority name string.

##### `dsc_keycontainername`

Data type: `Optional[String]`

Specifies the name of an existing private key container.

##### `dsc_keylength`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the bit length for new certification authority key.

##### `dsc_logdirectory`

Data type: `Optional[String]`

Specifies the folder location of the certification authority database log.

##### `dsc_outputcertrequestfile`

Data type: `Optional[String]`

Specifies the folder location for certificate request file.

##### `dsc_overwriteexistingcainds`

Data type: `Optional[Boolean]`

Specifies that the computer object in the Active Directory Domain Service domain should be overwritten with the same computer name.

##### `dsc_overwriteexistingdatabase`

Data type: `Optional[Boolean]`

Specifies that the existing certification authority database should be overwritten.

##### `dsc_overwriteexistingkey`

Data type: `Optional[Boolean]`

Overwrite existing key container with the same name

##### `dsc_parentca`

Data type: `Optional[String]`

Specifies the configuration string of the parent certification authority that will certify this CA.

##### `dsc_validityperiod`

Data type: `Optional[Enum['Hours', 'Days', 'Months', 'Years']]`

Specifies the validity period of the certification authority certificate in hours, days, weeks, months or years. If this is a subordinate CA, do not use this parameter, because the validity period is determined by the parent CA.

##### `dsc_validityperiodunits`

Data type: `Optional[Integer[0, 4294967295]]`

Validity period of the certification authority certificate. If this is a subordinate CA, do not specify this parameter because the validity period is determined by the parent CA.

#### Parameters

The following parameters are available in the `dsc_adcscertificationauthority` type.

* [`dsc_certfilepassword`](#dsc_certfilepassword)
* [`dsc_credential`](#dsc_credential)
* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_certfilepassword"></a>`dsc_certfilepassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the password for certification authority certificate file.

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

To install an enterprise certification authority, the computer must be joined to an Active Directory Domain Services
domain and a user account that is a member of the Enterprise Admin group is required. To install a standalone
certification authority, the computer can be in a workgroup or AD DS domain. If the computer is in a workgroup, a user
account that is a member of Administrators is required. If the computer is in an AD DS domain, a user account that is a
member of Domain Admins is required.

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_adcscertificationauthoritysettings"></a>`dsc_adcscertificationauthoritysettings`

The DSC AdcsCertificationAuthoritySettings resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcscertificationauthoritysettings` type.

##### `dsc_auditfilter`

Data type: `Optional[Array[Enum['StartAndStopADCS', 'BackupAndRestoreCADatabase', 'IssueAndManageCertificateRequests', 'RevokeCertificatesAndPublishCRLs', 'ChangeCASecuritySettings', 'StoreAndRetrieveArchivedKeys', 'ChangeCAConfiguration']]]`

Specifies an array of audit categories to enable audit logging for.

##### `dsc_cacertpublicationurls`

Data type: `Optional[Array[String]]`

Specifies an array of Certificate Authority certificate publication URLs, each prepended with an integer representing the type of URL endpoint.

##### `dsc_crloverlapperiod`

Data type: `Optional[Enum['Hours', 'Days', 'Weeks', 'Months', 'Years']]`

Specifies the units of measurement for the certificate revocation list overlap period.

##### `dsc_crloverlapunits`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of units for the certificate revocation list overlap period.

##### `dsc_crlperiod`

Data type: `Optional[Enum['Hours', 'Days', 'Weeks', 'Months', 'Years']]`

Specifies the units of measurement for the certificate revocation period.

##### `dsc_crlperiodunits`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of units for the certificate revocation period.

##### `dsc_crlpublicationurls`

Data type: `Optional[Array[String]]`

Specifies an array of Certificate Revocation List publication URLs, each prepended with an integer representing the type of URL endpoint.

##### `dsc_dsconfigdn`

Data type: `Optional[String]`

Specifies the distinguished name of the directory services configuration object that contains this certificate authority in the Active Directory.

##### `dsc_dsdomaindn`

Data type: `Optional[String]`

Specifies the distinguished name of the directory services object that contains this certificate authority in the Active Directory.

##### `dsc_validityperiod`

Data type: `Optional[Enum['Hours', 'Days', 'Weeks', 'Months', 'Years']]`

Specifies the units of measurement for the validity period of certificates issued by this certificate authority.

##### `dsc_validityperiodunits`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of units for the validity period of certificates issued by this certificate authority.

#### Parameters

The following parameters are available in the `dsc_adcscertificationauthoritysettings` type.

* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_adcsenrollmentpolicywebservice"></a>`dsc_adcsenrollmentpolicywebservice`

The DSC AdcsEnrollmentPolicyWebService resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcsenrollmentpolicywebservice` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Certificate Enrollment Policy Web feature should be installed or uninstalled. Defaults to Present.

##### `dsc_keybasedrenewal`

Data type: `Optional[Boolean]`

Configures the Certificate Enrollment Policy Web Service to operate in key-based renewal mode. Defaults to False.

##### `dsc_sslcertthumbprint`

Data type: `String`

Specifies the thumbprint of the certificate used by Internet Information Service (IIS) to enable support for required Secure Sockets Layer (SSL).

#### Parameters

The following parameters are available in the `dsc_adcsenrollmentpolicywebservice` type.

* [`dsc_authenticationtype`](#dsc_authenticationtype)
* [`dsc_credential`](#dsc_credential)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_authenticationtype"></a>`dsc_authenticationtype`

namevar

Data type: `Enum['Certificate', 'Kerberos', 'UserName']`

Specifies the authentication type used by the Certificate Enrollment Policy Web Service.

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

If the Certificate Enrollment Policy Web service is configured to use Standalone certification authority, then an
account that is a member of the local Administrators on the CA is required. If the Certificate Enrollment Policy Web
service is configured to use an Enterprise CA, then an account that is a member of Domain Admins is required.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_adcsonlineresponder"></a>`dsc_adcsonlineresponder`

The DSC AdcsOnlineResponder resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcsonlineresponder` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Online Responder feature should be installed or uninstalled.

#### Parameters

The following parameters are available in the `dsc_adcsonlineresponder` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

If the Online Responder service is configured to use Standalone certification authority, then an account that is a
member of the local Administrators on the CA is required. If the Online Responder service is configured to use an
Enterprise CA, then an account that is a member of Domain Admins is required.

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_adcstemplate"></a>`dsc_adcstemplate`

The DSC AdcsTemplate resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcstemplate` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the CA Template should be added or removed.

#### Parameters

The following parameters are available in the `dsc_adcstemplate` type.

* [`dsc_name`](#dsc_name)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_name"></a>`dsc_name`

namevar

Data type: `String`

Specifies the name of the CA template

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_adcswebenrollment"></a>`dsc_adcswebenrollment`

The DSC AdcsWebEnrollment resource type.
Automatically generated from version 5.0.0

#### Properties

The following properties are available in the `dsc_adcswebenrollment` type.

##### `dsc_caconfig`

Data type: `Optional[String]`

CAConfig parameter string. Do not specify this if there is a local CA installed.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Web Enrollment feature should be installed or uninstalled.

#### Parameters

The following parameters are available in the `dsc_adcswebenrollment` type.

* [`dsc_credential`](#dsc_credential)
* [`dsc_issingleinstance`](#dsc_issingleinstance)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

If the Web Enrollment service is configured to use Standalone certification authority, then an account that is a member
of the local Administrators on the CA is required. If the Web Enrollment service is configured to use an Enterprise CA,
then an account that is a member of Domain Admins is required.

##### <a name="dsc_issingleinstance"></a>`dsc_issingleinstance`

namevar

Data type: `Enum['Yes']`

Specifies the resource is a single instance, the value must be 'Yes'

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

